﻿namespace Reservation {
    using System.Diagnostics;
    using System.Xml.Serialization;
    using System;
    using System.Web.Services.Protocols;
    using System.Web.Services;
    
 	/// <summary>
	/// <p>Location Web service invocation.<br/>
	/// Generated with wsdl.exe.
	/// Only change: construction setting the URL.</p>
	/// <p>Copyright (c) 2002 Alexis Grandemange<br/>
	/// Mail: alexis.grandemange@pagebox.net</p>
	/// <pre>This program is free software; you can redistribute it and/or
	/// modify it under the terms of the GNU Lesser General Public
	/// License as published by the Free Software Foundation; version
	/// 2.1 of the License.
	/// This library is distributed in the hope that it will be useful,
	/// but WITHOUT ANY WARRANTY; without even the implied warranty of
	/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	/// GNU Lesser General Public License for more details.
	/// A copy of the GNU Lesser General Public License lesser.txt should be
	/// included in the distribution.</pre>
	/// </summary>
	[System.Web.Services.WebServiceBindingAttribute(Name="LocationSoap", Namespace="Reservation")]
    public class LocationProxy : System.Web.Services.Protocols.SoapHttpClientProtocol {
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        public LocationProxy(string url) {
            this.Url = url;
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("Reservation/Available", RequestNamespace="Reservation", ResponseNamespace="Reservation", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        [return: System.Xml.Serialization.XmlArrayItemAttribute("TimeEntry", IsNullable=true)]
        public TimeEntry[] Available(System.DateTime dt) {
            object[] results = this.Invoke("Available", new object[] {
                        dt});
            return ((TimeEntry[])(results[0]));
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        public System.IAsyncResult BeginAvailable(System.DateTime dt, System.AsyncCallback callback, object asyncState) {
            return this.BeginInvoke("Available", new object[] {
                        dt}, callback, asyncState);
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        public TimeEntry[] EndAvailable(System.IAsyncResult asyncResult) {
            object[] results = this.EndInvoke(asyncResult);
            return ((TimeEntry[])(results[0]));
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("Reservation/Notify", RequestNamespace="Reservation", ResponseNamespace="Reservation", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public Entry Notify(string url, string address, string city, string state, string zip, string country, string region, string latitude, string longitude) {
            object[] results = this.Invoke("Notify", new object[] {
                        url,
                        address,
                        city,
                        state,
                        zip,
                        country,
                        region,
                        latitude,
                        longitude});
            return ((Entry)(results[0]));
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        public System.IAsyncResult BeginNotify(string url, string address, string city, string state, string zip, string country, string region, string latitude, string longitude, System.AsyncCallback callback, object asyncState) {
            return this.BeginInvoke("Notify", new object[] {
                        url,
                        address,
                        city,
                        state,
                        zip,
                        country,
                        region,
                        latitude,
                        longitude}, callback, asyncState);
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        public Entry EndNotify(System.IAsyncResult asyncResult) {
            object[] results = this.EndInvoke(asyncResult);
            return ((Entry)(results[0]));
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        [System.Web.Services.Protocols.SoapDocumentMethodAttribute("Reservation/Unnotify", RequestNamespace="Reservation", ResponseNamespace="Reservation", Use=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)]
        public string Unnotify(string url) {
            object[] results = this.Invoke("Unnotify", new object[] {
                        url});
            return ((string)(results[0]));
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        public System.IAsyncResult BeginUnnotify(string url, System.AsyncCallback callback, object asyncState) {
            return this.BeginInvoke("Unnotify", new object[] {
                        url}, callback, asyncState);
        }
        
        [System.Diagnostics.DebuggerStepThroughAttribute()]
        public string EndUnnotify(System.IAsyncResult asyncResult) {
            object[] results = this.EndInvoke(asyncResult);
            return ((string)(results[0]));
        }
    }
    
    public class TimeEntry {
        
        public short hour;
        
        public short minutes;
    }
    
    [System.Xml.Serialization.XmlTypeAttribute(Namespace="Reservation")]
    public class Entry {
        
        public string url;
        
        public string address;
        
        public string city;
        
        public string state;
        
        public string zip;
        
        public string country;
        
        public string region;
        
        public string latitude;
        
        public string longitude;
    }
}
